searchData={"content_type":"text/markdown","items":[{"doc":"A wrapper around PropEr","ref":"PropEx.html","title":"PropEx","type":"module"},{"doc":"","ref":"PropEx.html#convert_argument_list/1","title":"PropEx.convert_argument_list/1","type":"function"},{"doc":"","ref":"PropEx.html#convert_argument_spec/1","title":"PropEx.convert_argument_spec/1","type":"function"},{"doc":"","ref":"PropEx.html#convert_typespec/1","title":"PropEx.convert_typespec/1","type":"function"},{"doc":"","ref":"PropEx.html#forall/2","title":"PropEx.forall/2","type":"macro"},{"doc":"","ref":"PropEx.html#get_arguments_of/2","title":"PropEx.get_arguments_of/2","type":"function"},{"doc":"","ref":"PropEx.Test.Arithmetics.html","title":"PropEx.Test.Arithmetics","type":"module"},{"doc":"","ref":"PropEx.Test.Arithmetics.html#add/2","title":"PropEx.Test.Arithmetics.add/2","type":"function"},{"doc":"","ref":"PropEx.Test.Arithmetics.html#sub/2","title":"PropEx.Test.Arithmetics.sub/2","type":"function"},{"doc":"","ref":"PropEx.Test.Strings.html","title":"PropEx.Test.Strings","type":"module"},{"doc":"","ref":"PropEx.Test.Strings.html#concat/2","title":"PropEx.Test.Strings.concat/2","type":"function"},{"doc":"","ref":"PropEx.TypespecClause.html","title":"PropEx.TypespecClause","type":"module"},{"doc":"","ref":"PropEx.TypespecClause.html#typespec_clause/2","title":"PropEx.TypespecClause.typespec_clause/2","type":"macro"},{"doc":"# PropEx\n![shitpost-y logo](assets/logo.png)\n\n ~~I swear this is not a shitpost~~ \n\nAn adaptation of PropEr for the Elixir world.\n\n**WARNING!:** As of right now, this is a prototype. Feel free to open issues and\nsend pull requests!","ref":"readme.html","title":"PropEx","type":"extras"},{"doc":"Add the library as a dependency for the `test` environment\n```elixir\ndefp deps do\n  [\n    {:propex, \"~> 0.1\", only: :test}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - PropEx","type":"extras"},{"doc":"Suppose that you want to test the following module:\n```elixir\n# lib/my_lib.ex\ndefmodule MyLib do\n  @spec add(a :: integer(), b :: integer()) :: integer()\n  def add(a, b), do: a + b\nend\n```\n\n#","ref":"readme.html#usage","title":"Usage - PropEx","type":"extras"},{"doc":"You can automatically generate the argument list assuming that you had written\na `@spec` for your function:\n```elixir\n# test/my_lib_test.exs\ndefmodule MyLibTest do\n  use ExUnit.Case\n  use PropEx\n\n  test \"add/2\" do\n    forall arguments_of MyLib.add/2 do\n      # a, b and result are assigned automatically\n      result - a == b &&\n      result - b == a\n    end\n  end\nend\n```\n\n#","ref":"readme.html#automatic","title":"Automatic - PropEx","type":"extras"},{"doc":"You can specify the variables and types yourself if you want to\n```elixir\n# test/my_lib_test.exs\ndefmodule MyLibTest do\n  use ExUnit.Case\n  use PropEx\n\n  test \"add/2\" do\n    forall [a :: integer(), b :: integer()] do\n      MyLib.add(a, b) == a + b\n    end\n  end\nend\n```","ref":"readme.html#manual","title":"Manual - PropEx","type":"extras"}]}